program selection_mas;

const N = 9;

{ paprastas masyvas }
var mas : array [1..N] of integer;

{ paprasta struktura }
type struktura = record
                   i1 : integer;
                   i2 : integer;
                   r1 : real;
                   r2 : real
                 end;
var str : array [1..N] of struktura;

{ struktura 'studentas' }
{type studentas = record
                   vardas : string;
                   pavarde : string;
                   stud_paz_nr : integer;
                   specialybe : string;
                   kursas : integer;
                   grupe : integer;
                   login : string
                 end;
var stud : array [1..N] of studentas;}

{------------------------------------------------------------}

{ paprasto masyvo inicializacija }
procedure inicializuoti_mas;
  var i : integer;
begin
  for i := 1 to N do mas[i] := 0
end;

{ skaiciaus paprastam masyve suradimas }
function rasti_mas (sk : integer) : boolean;
  var i : integer;
      b : boolean;
begin
  b := false;
  for i := 1 to N do
    if mas[i] = sk then
    begin
      b := true;
      break
    end;
  rasti_mas := b
end;

{ paprasto masyvo uzpildymas }
procedure uzpildyti_mas;
  var i, val : integer;
begin
  inicializuoti_mas ();
  randomize;
  for i := 1 to N do
  begin
    repeat
      val := 1 + random (99)
    until not rasti_mas(val);
    mas[i] := val
  end
end;

{ paprasto masyvo atspausdinimas }
procedure spausdinti_mas;
  var i : integer;
begin
  for i := 1 to N do write (' ', mas[i]);
  writeln
end;

{selection didejanciam paprastam masyvui}
procedure selection_mas_did;
  var i, j, min, t : integer;
begin
  for i := 1 to N-1 do
  begin
    writeln ('Rusiuojam didejanciai paprasta masyva...pradzia');
    min := i;
    for j := i+1 to N do
      if mas[j] < mas[min] then min := j;
    t := mas[i]; 
    mas[i] := mas[min]; 
    mas[min] := t;
    spausdinti_mas ()
  end;
  writeln ('Rusiuojam didejanciai paprasta masyva...pabaiga')
end;

{selection mazejanciam paprastam masyvui}
procedure selection_mas_maz;
  var i, j, min, t : integer;
begin
  writeln ('Rusiuojam mazejanciai paprasta masyva...pradzia');
  for i := 1 to N-1 do
  begin
    min := i;
    for j := i+1 to N do
      if mas[j] > mas[min] then min := j;
    t := mas[i]; 
    mas[i] := mas[min]; 
    mas[min] := t;
    spausdinti_mas ()
  end;
  writeln ('Rusiuojam mazejanciai paprasta masyva...pabaiga')
end;

{------------------------------------------------------------}

{ paprastos strukturos inicializacija }
procedure inicializuoti_str;
  var i : integer;
begin
  for i := 1 to N do
  begin
    str[i].i1 := 0;
    str[i].i2 := 0;
    str[i].r1 := 0;
    str[i].r2 := 0
  end
end;

{ skaiciaus paprastoje strukturoje suradimas }
function rasti_str (sk1, sk2 : integer) : boolean;
  var i : integer;
      b : boolean;
begin
  b := false;
  for i := 1 to N do
    if (str[i].i1 = sk1) or (str[i].i2 = sk2) then
    begin
      b := true;
      break
    end;
  rasti_str := b
end;

{ paprastos strukturos uzpildymas }
procedure uzpildyti_str;
  var i, val1, val2 : integer;
begin
  inicializuoti_str ();
  randomize;
  for i := 1 to N do
  begin
    repeat
      val1 := 1 + random (99);
      val2 := 1 + random (99);
    until not rasti_str(val1, val2);
    str[i].i1 := val1;
    str[i].i2 := val2
  end
end;

{ paprastos strukturos atspausdinimas }
procedure spausdinti_str;
  var i : integer;
begin
//  for i := 1 to N do write (' ', str[i].i1, '-', str[i].i2, '-', str[i].r1:2:2, '-', str[i].r2:2:2);
  for i := 1 to N do write (' ', str[i].i1);//, '-', str[i].i2);
  writeln
end;

{selection didejanciai paprastai strukturai}
procedure selection_str_did;
  var i, j, min : integer;
      t : struktura;
begin
  writeln ('Rusiuojam didejanciai paprasta struktura...pradzia');
  for i := 1 to N-1 do
  begin
    min := i;
    for j := i+1 to N do
      if str[j].i1 < str[min].i1 then min := j;
    t := str[i]; 
    str[i] := str[min]; 
    str[min] := t;
    spausdinti_str ()
    end;
  writeln ('Rusiuojam didejanciai paprasta struktura...pabaiga')
end;

{selection mazejanciai paprastai strukturai}
procedure selection_str_maz;
  var i, j, min : integer;
      t : struktura;
begin
  writeln ('Rusiuojam mazejanciai paprasta struktura...pradzia');
  for i := 1 to N-1 do
  begin
    min := i;
    for j := i+1 to N do
      if str[j].i1 > str[min].i1 then min := j;
    t := str[i]; 
    str[i] := str[min]; 
    str[min] := t;
    spausdinti_str ()
  end;
  writeln ('Rusiuojam mazejanciai paprasta struktura...pabaiga')
end;
{------------------------------------------------------------}

begin
  writeln;
  writeln ('Pradedama programa...');

  // selection didejanciai paprastam masyvui
  writeln;
  writeln ('--- Paprastam masyvui didejanciai ---');
  uzpildyti_mas ();
  write ('Nerusiuotas:');
  spausdinti_mas ();
  selection_mas_did ();
  write ('Surusiuotas:');
  spausdinti_mas ();

  // burbulas mazejanciai paprastam masyvui
  writeln;
  writeln ('--- Paprastam masyvui mazejanciai ---');
  uzpildyti_mas ();
  write ('Nerusiuotas:');
  spausdinti_mas ();
  selection_mas_maz ();
  write ('Surusiuotas:');
  spausdinti_mas ();

  // burbulas didejanciai paprastai strukturai
  writeln;
  writeln ('--- Paprastai strukturai didejanciai ---');
  uzpildyti_str ();
  write ('Nerusiuotas:');
  spausdinti_str ();
  selection_str_did ();
  write ('Surusiuotas:');
  spausdinti_str ();

  // burbulas mazejanciai paprastai strukturai
  writeln;
  writeln ('--- Paprastai strukturai mazejanciai ---');
  uzpildyti_str ();
  write ('Nerusiuotas:');
  spausdinti_str ();
  selection_str_maz ();
  write ('Surusiuotas:');
  spausdinti_str ();

  writeln;
  writeln ('Baigta programa.')
end.
